window.Gleam.initSearch([{"doc":"pink","title":"pink","content":"# pink\nBindings to [Ink](https://github.com/vadimdemedes/ink)\n\nA minimal React-like library for building terminal UIs.\n\n[![Package Version](https://img.shields.io/hexpm/v/pink)](https://hex.pm/packages/pink)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/pink/)\n\n## Installation\n\nThis package depends on Ink and React. The specific versions listed below are recommended because they have been tested with this package. Using other versions may lead to unexpected results.\n\n```sh\nnpm install ink@5.0 ink-spinner@5.0 react@18.3\n```\n\nTo add the Pink package to your Gleam project, use the following command:\n\n```sh\ngleam add pink\n```\n\nHere&#39;s a basic example of how to use Pink:\n\n```gleam\nimport pink\nimport pink/attribute\nimport pink/state\n\npub fn main() {\n    // Create a new React component (we need this to use hooks)\n    use &lt;- pink.component()\n\n    // Initialize a state (this is React&#39;s useState hook)\n    let message = state.init(&quot;World&quot;)\n\n    // Create a box with a border and a text component inside\n    pink.box([attribute.border_style(attribute.BorderSingle)], [\n        pink.text([], &quot;Hello, &quot; &lt;&gt; state.get(message))\n    ])\n}\n```\n","url":"index.html"},{"doc":"pink/attribute","title":"AlignItems","content":"pub type AlignItems {\n  ItemsStart\n  ItemsCenter\n  ItemsEnd\n}\n `AlignItems` is the type the function `align_items` accepts\nItemsStart\n\n\nItemsCenter\n\n\nItemsEnd\n\n\nSynonyms:\npink/attribute.AlignItems\npink/attribute AlignItems","url":"pink/attribute.html#AlignItems"},{"doc":"pink/attribute","title":"AlignSelf","content":"pub type AlignSelf {\n  SelfAuto\n  SelfStart\n  SelfCenter\n  SelfEnd\n}\n `AlignSelf` is the type the function `align_self` accepts\nSelfAuto\n\n\nSelfStart\n\n\nSelfCenter\n\n\nSelfEnd\n\n\nSynonyms:\npink/attribute.AlignSelf\npink/attribute AlignSelf","url":"pink/attribute.html#AlignSelf"},{"doc":"pink/attribute","title":"Attribute","content":"pub opaque type Attribute\n `Attribute` is a type that represents an attribute of an element\n\nSynonyms:\npink/attribute.Attribute\npink/attribute Attribute","url":"pink/attribute.html#Attribute"},{"doc":"pink/attribute","title":"BorderStyle","content":"pub type BorderStyle {\n  BorderSingle\n  BorderDouble\n  BorderRound\n  BorderBold\n  BorderSingleDouble\n  BorderDoubleSingle\n  BorderClassic\n  BorderCustom(\n    top_left: String,\n    top: String,\n    top_right: String,\n    left: String,\n    bottom_left: String,\n    bottom: String,\n    bottom_right: String,\n    right: String,\n  )\n}\n `BorderStyle` is the type the function `border_style` accepts\nBorderSingle\n\n\nBorderDouble\n\n\nBorderRound\n\n\nBorderBold\n\n\nBorderSingleDouble\n\n\nBorderDoubleSingle\n\n\nBorderClassic\n\n\nBorderCustom(\n  top_left: String,\n  top: String,\n  top_right: String,\n  left: String,\n  bottom_left: String,\n  bottom: String,\n  bottom_right: String,\n  right: String,\n)\n\n\nSynonyms:\npink/attribute.BorderStyle\npink/attribute BorderStyle","url":"pink/attribute.html#BorderStyle"},{"doc":"pink/attribute","title":"Dimension","content":"pub type Dimension {\n  Spaces(Int)\n  Percent(Int)\n}\n `Dimension` is the type some functions accept\nSpaces(Int)\n\n\nPercent(Int)\n\n\nSynonyms:\npink/attribute.Dimension\npink/attribute Dimension","url":"pink/attribute.html#Dimension"},{"doc":"pink/attribute","title":"Display","content":"pub type Display {\n  DisplayFlex\n  DisplayNone\n}\n `Display` is the type the function `display` accepts\nDisplayFlex\n\n\nDisplayNone\n\n\nSynonyms:\npink/attribute.Display\npink/attribute Display","url":"pink/attribute.html#Display"},{"doc":"pink/attribute","title":"FlexDirection","content":"pub type FlexDirection {\n  FlexRow\n  FlexColumn\n  FlexRowReverse\n  FlexColumnReverse\n}\n `FlexDirection` is the type the function `flex_direction` accepts\nFlexRow\n\n\nFlexColumn\n\n\nFlexRowReverse\n\n\nFlexColumnReverse\n\n\nSynonyms:\npink/attribute.FlexDirection\npink/attribute FlexDirection","url":"pink/attribute.html#FlexDirection"},{"doc":"pink/attribute","title":"FlexWrap","content":"pub type FlexWrap {\n  FlexWrap\n  FlexNoWrap\n  FlexWrapReverse\n}\n `FlexWrap` is the type the function `flex_wrap` accepts\nFlexWrap\n\n\nFlexNoWrap\n\n\nFlexWrapReverse\n\n\nSynonyms:\npink/attribute.FlexWrap\npink/attribute FlexWrap","url":"pink/attribute.html#FlexWrap"},{"doc":"pink/attribute","title":"JustifyContent","content":"pub type JustifyContent {\n  ContentStart\n  ContentCenter\n  ContentEnd\n  ContentSpaceBetween\n  ContentSpaceAround\n}\n `JustifyContent` is the type the function `justify_content` accepts\nContentStart\n\n\nContentCenter\n\n\nContentEnd\n\n\nContentSpaceBetween\n\n\nContentSpaceAround\n\n\nSynonyms:\npink/attribute.JustifyContent\npink/attribute JustifyContent","url":"pink/attribute.html#JustifyContent"},{"doc":"pink/attribute","title":"Visibility","content":"pub type Visibility {\n  Visible\n  Hidden\n}\n `Visibility` is the type the overflow functions accept\nVisible\n\n\nHidden\n\n\nSynonyms:\npink/attribute.Visibility\npink/attribute Visibility","url":"pink/attribute.html#Visibility"},{"doc":"pink/attribute","title":"Wrap","content":"pub type Wrap {\n  Wrap\n  Truncate\n  TruncateStart\n  TruncateMiddle\n  TruncateEnd\n}\n `Wrap` is the type the function `wrap` accepts\nWrap\n\n\nTruncate\n\n\nTruncateStart\n\n\nTruncateMiddle\n\n\nTruncateEnd\n\n\nSynonyms:\npink/attribute.Wrap\npink/attribute Wrap","url":"pink/attribute.html#Wrap"},{"doc":"pink/attribute","title":"align_items","content":"pub fn align_items(align: AlignItems) -&gt; Attribute\n Effects how elements are aligned both in Flexbox and Grid layouts\n For more information, see [align-items](https://css-tricks.com/almanac/properties/a/align-items/)\n\n ## Examples\n \n box([align_items(ItemsStart)], [\n   box([margin_right(1)], [text([], &quot;X&quot;)]),\n   text_nested([], [\n      text([], &quot;A&quot;),\n      newline([]),\n      text([], &quot;B&quot;),\n      newline([]),\n      text([], &quot;C&quot;),\n   ]),\n ])\n // -&gt; X A\n // -&gt;   B\n // -&gt;   C\n \n \n box([align_items(ItemsCenter)], [\n   box([margin_right(1)], [text([], &quot;X&quot;)]),\n   text_nested([], [\n      text([], &quot;A&quot;),\n      newline([]),\n      text([], &quot;B&quot;),\n      newline([]),\n      text([], &quot;C&quot;),\n   ]),\n ])\n // -&gt;   A\n // -&gt; X B\n // -&gt;   C\n \n \n box([align_items(ItemsEnd)], [\n   box([margin_right(1)], [text([], &quot;X&quot;)]),\n   text_nested([], [\n      text([], &quot;A&quot;),\n      newline([]),\n      text([], &quot;B&quot;),\n      newline([]),\n      text([], &quot;C&quot;),\n   ]),\n ])\n // -&gt;   A\n // -&gt;   B\n // -&gt; X C\n \nSynonyms:\npink/attribute.align_items\npink/attribute align_items","url":"pink/attribute.html#align_items"},{"doc":"pink/attribute","title":"align_self","content":"pub fn align_self(align: AlignSelf) -&gt; Attribute\n Makes possible to override the align-items value for specific flex items\n For more information, see [align-self](https://css-tricks.com/almanac/properties/a/align-self/)\n\n ## Examples\n \n box([height(Spaces(3))], [\n   box([align_self(SelfStart)], [text([], &quot;X&quot;)]),\n ])\n // -&gt; X\n // -&gt;\n // -&gt;\n \n \n box([height(Spaces(3))], [\n   box([align_self(SelfCenter)], [text([], &quot;X&quot;)]),\n ])\n // -&gt;\n // -&gt; X\n // -&gt;\n \n \n box([height(Spaces(3))], [\n   box([align_self(SelfEnd)], [text([], &quot;X&quot;)]),\n ])\n // -&gt;\n // -&gt;\n // -&gt; X\n \nSynonyms:\npink/attribute.align_self\npink/attribute align_self","url":"pink/attribute.html#align_self"},{"doc":"pink/attribute","title":"background_color","content":"pub fn background_color(color: String) -&gt; Attribute\n Change text background color. Ink uses chalk under the hood, so all its functionality is supported\n\n ## Examples\n \n text([background_color(&quot;green&quot;)], &quot;Green&quot;)\n text([background_color(&quot;#005cc5&quot;)], &quot;Blue&quot;)\n text([background_color(&quot;rgb(232, 131, 136)&quot;)], &quot;Red&quot;)\n \nSynonyms:\npink/attribute.background_color\npink/attribute background_color","url":"pink/attribute.html#background_color"},{"doc":"pink/attribute","title":"bold","content":"pub fn bold(is_bold: Bool) -&gt; Attribute\n Make the text bold\nSynonyms:\npink/attribute.bold\npink/attribute bold","url":"pink/attribute.html#bold"},{"doc":"pink/attribute","title":"border_bottom","content":"pub fn border_bottom(has_border: Bool) -&gt; Attribute\n Determines whether bottom border is visible\nSynonyms:\npink/attribute.border_bottom\npink/attribute border_bottom","url":"pink/attribute.html#border_bottom"},{"doc":"pink/attribute","title":"border_bottom_color","content":"pub fn border_bottom_color(color: String) -&gt; Attribute\n Change bottom border color. Accepts the same values as `color` in `text` function\n\n ## Examples\n \n box([border_style(BorderRound), border_bottom_color(&quot;green&quot;)], [\n   text([], &quot;Hello world&quot;)\n ])\n \nSynonyms:\npink/attribute.border_bottom_color\npink/attribute border_bottom_color","url":"pink/attribute.html#border_bottom_color"},{"doc":"pink/attribute","title":"border_bottom_dim_color","content":"pub fn border_bottom_dim_color(has_color: Bool) -&gt; Attribute\n Dim the bottom border color.\n\n ## Examples\n \n box([border_style(BorderRound), border_bottom_dim_color(True)], [\n   text([], &quot;Hello world&quot;)\n ])\n \nSynonyms:\npink/attribute.border_bottom_dim_color\npink/attribute border_bottom_dim_color","url":"pink/attribute.html#border_bottom_dim_color"},{"doc":"pink/attribute","title":"border_color","content":"pub fn border_color(color: String) -&gt; Attribute\n Change border color.\n Shorthand for setting `border_top_color`, `border_right_color`, `border_bottom_color` and `border_left_color`.\n\n ## Examples\n \n box([border_style(BorderRound), border_color(&quot;green&quot;)], [\n   text([], &quot;Green Rounded Box&quot;)\n ])\n \nSynonyms:\npink/attribute.border_color\npink/attribute border_color","url":"pink/attribute.html#border_color"},{"doc":"pink/attribute","title":"border_dim_color","content":"pub fn border_dim_color(has_color: Bool) -&gt; Attribute\n Dim the border color.\n\n ## Examples\n \n box([border_style(BorderRound), border_dim_color(True)], [\n   text([], &quot;Hello world&quot;)\n ])\n \nSynonyms:\npink/attribute.border_dim_color\npink/attribute border_dim_color","url":"pink/attribute.html#border_dim_color"},{"doc":"pink/attribute","title":"border_left","content":"pub fn border_left(has_border: Bool) -&gt; Attribute\n Determines whether left border is visible\nSynonyms:\npink/attribute.border_left\npink/attribute border_left","url":"pink/attribute.html#border_left"},{"doc":"pink/attribute","title":"border_left_color","content":"pub fn border_left_color(color: String) -&gt; Attribute\n Change left border color. Accepts the same values as `color` in `text` function\n\n ## Examples\n \n box([border_style(BorderRound), border_left_color(&quot;green&quot;)], [\n   text([], &quot;Hello world&quot;)\n ])\n \nSynonyms:\npink/attribute.border_left_color\npink/attribute border_left_color","url":"pink/attribute.html#border_left_color"},{"doc":"pink/attribute","title":"border_left_dim_color","content":"pub fn border_left_dim_color(has_color: Bool) -&gt; Attribute\n Dim the left border color.\n\n ## Examples\n \n box([border_style(BorderRound), border_left_dim_color(True)], [\n   text([], &quot;Hello world&quot;)\n ])\n \nSynonyms:\npink/attribute.border_left_dim_color\npink/attribute border_left_dim_color","url":"pink/attribute.html#border_left_dim_color"},{"doc":"pink/attribute","title":"border_right","content":"pub fn border_right(has_border: Bool) -&gt; Attribute\n Determines whether right border is visible\nSynonyms:\npink/attribute.border_right\npink/attribute border_right","url":"pink/attribute.html#border_right"},{"doc":"pink/attribute","title":"border_right_color","content":"pub fn border_right_color(color: String) -&gt; Attribute\n Change right border color. Accepts the same values as `color` in `text` function\n\n ## Examples\n \n box([border_style(BorderRound), border_right_color(&quot;green&quot;)], [\n   text([], &quot;Hello world&quot;)\n ])\n \nSynonyms:\npink/attribute.border_right_color\npink/attribute border_right_color","url":"pink/attribute.html#border_right_color"},{"doc":"pink/attribute","title":"border_right_dim_color","content":"pub fn border_right_dim_color(has_color: Bool) -&gt; Attribute\n Dim the right border color.\n\n ## Examples\n \n box([border_style(BorderRound), border_right_dim_color(True)], [\n   text([], &quot;Hello world&quot;)\n ])\n \nSynonyms:\npink/attribute.border_right_dim_color\npink/attribute border_right_dim_color","url":"pink/attribute.html#border_right_dim_color"},{"doc":"pink/attribute","title":"border_style","content":"pub fn border_style(style: BorderStyle) -&gt; Attribute\n Add a border with a specified style.\n If `border_style` is not set, no border will be added.\n Ink uses border styles from [cli-boxes](https://github.com/sindresorhus/cli-boxes) module.\n\n ## Examples\n \n box([border_style(BorderSingle)], [text([], &quot;single&quot;)])\n // -&gt; ┌──────┐\n // -&gt; │single│\n // -&gt; └──────┘\n \n \n box([border_style(BorderDouble)], [text([], &quot;double&quot;)])\n // -&gt; ╔══════╗\n // -&gt; ║double║\n // -&gt; ╚══════╝\n \n \n box([border_style(BorderRound)], [text([], &quot;round&quot;)])\n // -&gt; ╭─────╮\n // -&gt; │round│\n // -&gt; ╰─────╯\n \n \n box([border_style(BorderBold)], [text([], &quot;bold&quot;)])\n // -&gt; ┏━━━━┓\n // -&gt; ┃bold┃\n // -&gt; ┗━━━━┛\n \n \n box([border_style(BorderSingleDouble)], [text([], &quot;single double&quot;)])\n // -&gt; ╓─────────────╖\n // -&gt; ║single double║\n // -&gt; ╙─────────────╜\n \n \n box([border_style(BorderDoubleSingle)], [text([], &quot;double single&quot;)])\n // -&gt; ╒═════════════╕\n // -&gt; │double single│\n // -&gt; ╘═════════════╛\n \n \n box([border_style(BorderClassic)], [text([], &quot;classic&quot;)])\n // -&gt; +-------+\n // -&gt; |classic|\n // -&gt; +-------+\n \nSynonyms:\npink/attribute.border_style\npink/attribute border_style","url":"pink/attribute.html#border_style"},{"doc":"pink/attribute","title":"border_top","content":"pub fn border_top(has_border: Bool) -&gt; Attribute\n Determines whether top border is visible\nSynonyms:\npink/attribute.border_top\npink/attribute border_top","url":"pink/attribute.html#border_top"},{"doc":"pink/attribute","title":"border_top_color","content":"pub fn border_top_color(color: String) -&gt; Attribute\n Change top border color. Accepts the same values as `color` in `text` function\n\n ## Examples\n \n box([border_style(BorderRound), border_top_color(&quot;green&quot;)], [\n   text([], &quot;Hello world&quot;)\n ])\n \nSynonyms:\npink/attribute.border_top_color\npink/attribute border_top_color","url":"pink/attribute.html#border_top_color"},{"doc":"pink/attribute","title":"border_top_dim_color","content":"pub fn border_top_dim_color(has_color: Bool) -&gt; Attribute\n Dim the top border color.\n\n ## Examples\n \n box([border_style(BorderRound), border_top_dim_color(True)], [\n   text([], &quot;Hello world&quot;)\n ])\n \nSynonyms:\npink/attribute.border_top_dim_color\npink/attribute border_top_dim_color","url":"pink/attribute.html#border_top_dim_color"},{"doc":"pink/attribute","title":"color","content":"pub fn color(color: String) -&gt; Attribute\n Change text color. Ink uses chalk under the hood, so all its functionality is supported\n\n ## Examples\n \n text([color(&quot;green&quot;)], &quot;Green&quot;)\n text([color(&quot;#005cc5&quot;)], &quot;Blue&quot;)\n text([color(&quot;rgb(232, 131, 136)&quot;)], &quot;Red&quot;)\n \nSynonyms:\npink/attribute.color\npink/attribute color","url":"pink/attribute.html#color"},{"doc":"pink/attribute","title":"column_gap","content":"pub fn column_gap(gap: Int) -&gt; Attribute\n Size of the gap between an element&#39;s columns\n\n ## Examples\n \n box([column_gap(1)], [\n   text([], &quot;A&quot;),\n   text([], &quot;B&quot;),\n ])\n // -&gt; A B\n \nSynonyms:\npink/attribute.column_gap\npink/attribute column_gap","url":"pink/attribute.html#column_gap"},{"doc":"pink/attribute","title":"count","content":"pub fn count(count: Int) -&gt; Attribute\n Number of newlines to insert\nSynonyms:\npink/attribute.count\npink/attribute count","url":"pink/attribute.html#count"},{"doc":"pink/attribute","title":"custom","content":"pub fn custom(key: String, value: Json) -&gt; Attribute\n Create a custom attribute\n Useful for passing custom data to components or for setting attributes that are not yet supported by Pink\nSynonyms:\npink/attribute.custom\npink/attribute custom","url":"pink/attribute.html#custom"},{"doc":"pink/attribute","title":"dim_color","content":"pub fn dim_color(color: String) -&gt; Attribute\n Dim the color (emit a small amount of light)\n\n ## Examples\n \n text([dim_color(&quot;red&quot;)], &quot;Dimmed red&quot;)\n \nSynonyms:\npink/attribute.dim_color\npink/attribute dim_color","url":"pink/attribute.html#dim_color"},{"doc":"pink/attribute","title":"display","content":"pub fn display(display: Display) -&gt; Attribute\n Set this property to `DisplayNone` to hide the element\nSynonyms:\npink/attribute.display\npink/attribute display","url":"pink/attribute.html#display"},{"doc":"pink/attribute","title":"encode","content":"pub fn encode(attributes: List(Attribute)) -&gt; Json\n\nSynonyms:\npink/attribute.encode\npink/attribute encode","url":"pink/attribute.html#encode"},{"doc":"pink/attribute","title":"flex_basis","content":"pub fn flex_basis(basis: Dimension) -&gt; Attribute\n Specifies the initial size of the flex item, before any available space is distributed according to the flex factors.\n When omitted from the flex shorthand, its specified value is the length zero\n For more information, see [flex-basis](https://css-tricks.com/almanac/properties/f/flex-basis/)\n\n ## Examples\n \n box([width(6)], [\n   box([flex_basis(Spaces(3))], [\n     text([], &quot;X&quot;)\n   ]),\n   text([], &quot;Y&quot;)\n ])\n // -&gt; X  Y\n \n \n box([width(6)], [\n   box([flex_basis(Percent(50))], [\n     text([], &quot;X&quot;)\n   ]),\n   text([], &quot;Y&quot;)\n ])\n // -&gt; X  Y\n \nSynonyms:\npink/attribute.flex_basis\npink/attribute flex_basis","url":"pink/attribute.html#flex_basis"},{"doc":"pink/attribute","title":"flex_direction","content":"pub fn flex_direction(direction: FlexDirection) -&gt; Attribute\n Establishes the main-axis, thus defining the direction flex items are placed in the flex container\n For more information, see [flex-direction](https://css-tricks.com/almanac/properties/f/flex-direction/)\n\n ## Examples\n \n box([], [\n   box([margin_right(1)], [\n     text([], &quot;X&quot;)\n   ]),\n   text([], &quot;Y&quot;)\n ])\n // -&gt; X Y\n \n \n box([flex_direction(FlexRowReverse)], [\n   text([], &quot;X&quot;),\n   box([margin_right(1)], [\n     text([], &quot;Y&quot;)\n   ])\n ])\n // -&gt; Y X\n \n \n box([flex_direction(FlexColumn)], [\n   text([], &quot;X&quot;),\n   text([], &quot;Y&quot;)\n ])\n // -&gt; X\n // -&gt; Y\n \n \n box([flex_direction(FlexColumnReverse)], [\n   text([], &quot;X&quot;),\n   text([], &quot;Y&quot;)\n ])\n // -&gt; Y\n // -&gt; X\n \nSynonyms:\npink/attribute.flex_direction\npink/attribute flex_direction","url":"pink/attribute.html#flex_direction"},{"doc":"pink/attribute","title":"flex_grow","content":"pub fn flex_grow(grow: Int) -&gt; Attribute\n Defines the ability for a flex item to grow if necessary. It accepts a unitless value that serves as a proportion. It dictates what amount of the available space inside the flex container the item should take up\n For more information, see [flex-grow](https://css-tricks.com/almanac/properties/f/flex-grow/)\n\n ## Examples\n \n box([], [\n   text([], &quot;Label&quot;),\n   box([flex_grow(1)], [\n     text([], &quot;Fills all remaining space&quot;)\n   ])\n ])\n \nSynonyms:\npink/attribute.flex_grow\npink/attribute flex_grow","url":"pink/attribute.html#flex_grow"},{"doc":"pink/attribute","title":"flex_shrink","content":"pub fn flex_shrink(shrink: Int) -&gt; Attribute\n Specifies the “flex shrink factor” which determines how much the flex item will shrink relative to the rest of the flex items in the flex container when there isn’t enough space on the row\n For more information, see [flex-shrink](https://css-tricks.com/almanac/properties/f/flex-shrink/)\n\n ## Examples\n \n box([width(20)], [\n   box([flex_shrink(2), width(10)], [\n     text([], &quot;Will be 1/4&quot;)\n   ]),\n   box([width(10)], [\n     text([], &quot;Will be 3/4&quot;)\n   ]),\n ])\n \nSynonyms:\npink/attribute.flex_shrink\npink/attribute flex_shrink","url":"pink/attribute.html#flex_shrink"},{"doc":"pink/attribute","title":"flex_wrap","content":"pub fn flex_wrap(wrap: FlexWrap) -&gt; Attribute\n Defines whether the flex items are forced in a single line or can be flowed into multiple lines.\n If set to multiple lines, it also defines the cross-axis which determines the direction new lines are stacked in, aiding responsiveness layout behavior without CSS media queries\n For more information, see [flex-wrap](https://css-tricks.com/almanac/properties/f/flex-wrap/)\n\n ## Examples\n \n box([width(2), flex_wrap(FlexWrap)], [\n   text([], &quot;A&quot;),\n   text([], &quot;BC&quot;)\n ])\n // -&gt; A\n // -&gt; BC\n \n \n box([flex_direction(FlexColumn), height(2), flex_wrap(FlexWrap)], [\n   text([], &quot;A&quot;),\n   text([], &quot;B&quot;),\n   text([], &quot;C&quot;)\n ])\n // -&gt; AC\n // -&gt; B\n \nSynonyms:\npink/attribute.flex_wrap\npink/attribute flex_wrap","url":"pink/attribute.html#flex_wrap"},{"doc":"pink/attribute","title":"gap","content":"pub fn gap(gap: Int) -&gt; Attribute\n Size of the gap between an element&#39;s columns and rows. Shorthand for column_gap and row_gap\n\n ## Examples\n \n box([gap(1), width(3), flex_wrap(FlexWrap)], [\n   text([], &quot;A&quot;),\n   text([], &quot;B&quot;),\n   text([], &quot;C&quot;)\n ])\n // -&gt; A B\n // -&gt;\n // -&gt; C\n \nSynonyms:\npink/attribute.gap\npink/attribute gap","url":"pink/attribute.html#gap"},{"doc":"pink/attribute","title":"height","content":"pub fn height(height: Dimension) -&gt; Attribute\n Height of the element.\n You can set it in lines (rows) or in percent, which will calculate the height based on the height of parent element\n ## Examples\n \n box([height(Spaces(4))], [text([], &quot;X&quot;)])\n // -&gt; X\\n\\n\\n\n \n \n box([height(Spaces(6)), flex_direction(FlexColumn)], [\n   box([width(Percent(50))], [text([], &quot;X&quot;)]),\n   text([], &quot;Y&quot;)\n ])\n // -&gt; X\\n\\n\\nY\\n\\n\\n\n \nSynonyms:\npink/attribute.height\npink/attribute height","url":"pink/attribute.html#height"},{"doc":"pink/attribute","title":"inverse","content":"pub fn inverse(is_inverse: Bool) -&gt; Attribute\n Inverse background and foreground colors\n\n ## Examples\n \n text([inverse(True), color(&quot;yellow&quot;)], &quot;Inversed Yellow&quot;)\n \nSynonyms:\npink/attribute.inverse\npink/attribute inverse","url":"pink/attribute.html#inverse"},{"doc":"pink/attribute","title":"italic","content":"pub fn italic(is_italic: Bool) -&gt; Attribute\n Make the text italic\nSynonyms:\npink/attribute.italic\npink/attribute italic","url":"pink/attribute.html#italic"},{"doc":"pink/attribute","title":"justify_content","content":"pub fn justify_content(justify: JustifyContent) -&gt; Attribute\n Defines the alignment along the main axis.\n It helps distribute extra free space leftover when either all the flex items on a line are inflexible, or are flexible but have reached their maximum size.\n It also exerts some control over the alignment of items when they overflow the line\n For more information, see [justify-content](https://css-tricks.com/almanac/properties/j/justify-content/)\n\n ## Examples\n \n box([justify_content(ContentStart)], [\n   text([], &quot;X&quot;)\n ])\n // -&gt; &quot;X      &quot;\n \n \n box([justify_content(ContentCenter)], [\n   text([], &quot;X&quot;)\n ])\n // -&gt; &quot;   X   &quot;\n \n \n box([justify_content(ContentEnd)], [\n   text([], &quot;X&quot;)\n ])\n // -&gt; &quot;      X&quot;\n \n \n box([justify_content(ContentSpaceBetween)], [\n   text([], &quot;X&quot;),\n   text([], &quot;Y&quot;)\n ])\n // -&gt; &quot;X     Y&quot;\n \n \n box([justify_content(ContentSpaceAround)], [\n   text([], &quot;X&quot;),\n   text([], &quot;Y&quot;)\n ])\n // -&gt; &quot;  X   Y  &quot;\n \nSynonyms:\npink/attribute.justify_content\npink/attribute justify_content","url":"pink/attribute.html#justify_content"},{"doc":"pink/attribute","title":"key","content":"pub fn key(key: String) -&gt; Attribute\n Set a unique key for the element\n Useful for components that are rendered in a loop\nSynonyms:\npink/attribute.key\npink/attribute key","url":"pink/attribute.html#key"},{"doc":"pink/attribute","title":"margin","content":"pub fn margin(margin: Int) -&gt; Attribute\n Margin on all sides. Equivalent to setting margin_top, margin_bottom, margin_left and margin_right\nSynonyms:\npink/attribute.margin\npink/attribute margin","url":"pink/attribute.html#margin"},{"doc":"pink/attribute","title":"margin_bottom","content":"pub fn margin_bottom(margin: Int) -&gt; Attribute\n Bottom margin\nSynonyms:\npink/attribute.margin_bottom\npink/attribute margin_bottom","url":"pink/attribute.html#margin_bottom"},{"doc":"pink/attribute","title":"margin_left","content":"pub fn margin_left(margin: Int) -&gt; Attribute\n Left margin\nSynonyms:\npink/attribute.margin_left\npink/attribute margin_left","url":"pink/attribute.html#margin_left"},{"doc":"pink/attribute","title":"margin_right","content":"pub fn margin_right(margin: Int) -&gt; Attribute\n Right margin\nSynonyms:\npink/attribute.margin_right\npink/attribute margin_right","url":"pink/attribute.html#margin_right"},{"doc":"pink/attribute","title":"margin_top","content":"pub fn margin_top(margin: Int) -&gt; Attribute\n Top margin\nSynonyms:\npink/attribute.margin_top\npink/attribute margin_top","url":"pink/attribute.html#margin_top"},{"doc":"pink/attribute","title":"margin_x","content":"pub fn margin_x(margin: Int) -&gt; Attribute\n Horizontal margin. Equivalent to setting margin_left and margin_right\nSynonyms:\npink/attribute.margin_x\npink/attribute margin_x","url":"pink/attribute.html#margin_x"},{"doc":"pink/attribute","title":"margin_y","content":"pub fn margin_y(margin: Int) -&gt; Attribute\n Vertical margin. Equivalent to setting margin_top and margin_bottom\nSynonyms:\npink/attribute.margin_y\npink/attribute margin_y","url":"pink/attribute.html#margin_y"},{"doc":"pink/attribute","title":"min_height","content":"pub fn min_height(height: Int) -&gt; Attribute\n Sets a minimum height of the element\nSynonyms:\npink/attribute.min_height\npink/attribute min_height","url":"pink/attribute.html#min_height"},{"doc":"pink/attribute","title":"min_width","content":"pub fn min_width(width: Int) -&gt; Attribute\n Sets a minimum width of the element\nSynonyms:\npink/attribute.min_width\npink/attribute min_width","url":"pink/attribute.html#min_width"},{"doc":"pink/attribute","title":"overflow","content":"pub fn overflow(overflow: Visibility) -&gt; Attribute\n Shortcut for setting `overflow_x` and `overflow_y` at the same time\nSynonyms:\npink/attribute.overflow\npink/attribute overflow","url":"pink/attribute.html#overflow"},{"doc":"pink/attribute","title":"overflow_x","content":"pub fn overflow_x(overflow: Visibility) -&gt; Attribute\n Behavior for an element&#39;s overflow in horizontal direction.\nSynonyms:\npink/attribute.overflow_x\npink/attribute overflow_x","url":"pink/attribute.html#overflow_x"},{"doc":"pink/attribute","title":"overflow_y","content":"pub fn overflow_y(overflow: Visibility) -&gt; Attribute\n Behavior for an element&#39;s overflow in vertical direction.\nSynonyms:\npink/attribute.overflow_y\npink/attribute overflow_y","url":"pink/attribute.html#overflow_y"},{"doc":"pink/attribute","title":"padding","content":"pub fn padding(padding: Int) -&gt; Attribute\n Padding on all sides. Equivalent to setting padding_top, padding_bottom, padding_left and padding_right\nSynonyms:\npink/attribute.padding\npink/attribute padding","url":"pink/attribute.html#padding"},{"doc":"pink/attribute","title":"padding_bottom","content":"pub fn padding_bottom(padding: Int) -&gt; Attribute\n Bottom padding\nSynonyms:\npink/attribute.padding_bottom\npink/attribute padding_bottom","url":"pink/attribute.html#padding_bottom"},{"doc":"pink/attribute","title":"padding_left","content":"pub fn padding_left(padding: Int) -&gt; Attribute\n Left padding\nSynonyms:\npink/attribute.padding_left\npink/attribute padding_left","url":"pink/attribute.html#padding_left"},{"doc":"pink/attribute","title":"padding_right","content":"pub fn padding_right(padding: Int) -&gt; Attribute\n Right padding\nSynonyms:\npink/attribute.padding_right\npink/attribute padding_right","url":"pink/attribute.html#padding_right"},{"doc":"pink/attribute","title":"padding_top","content":"pub fn padding_top(padding: Int) -&gt; Attribute\n Top padding\nSynonyms:\npink/attribute.padding_top\npink/attribute padding_top","url":"pink/attribute.html#padding_top"},{"doc":"pink/attribute","title":"padding_x","content":"pub fn padding_x(padding: Int) -&gt; Attribute\n Horizontal padding. Equivalent to setting padding_left and padding_right\nSynonyms:\npink/attribute.padding_x\npink/attribute padding_x","url":"pink/attribute.html#padding_x"},{"doc":"pink/attribute","title":"padding_y","content":"pub fn padding_y(padding: Int) -&gt; Attribute\n Vertical padding. Equivalent to setting padding_top and padding_bottom\nSynonyms:\npink/attribute.padding_y\npink/attribute padding_y","url":"pink/attribute.html#padding_y"},{"doc":"pink/attribute","title":"row_gap","content":"pub fn row_gap(gap: Int) -&gt; Attribute\n Size of the gap between an element&#39;s rows\n\n ## Examples\n \n box([flex_direction(FlexColumn), row_gap(1)], [\n   text([], &quot;A&quot;),\n   text([], &quot;B&quot;),\n ])\n // -&gt; A\n // -&gt;\n // -&gt; B\n \nSynonyms:\npink/attribute.row_gap\npink/attribute row_gap","url":"pink/attribute.html#row_gap"},{"doc":"pink/attribute","title":"strikethrough","content":"pub fn strikethrough(is_strikethrough: Bool) -&gt; Attribute\n Make the text crossed with a line\nSynonyms:\npink/attribute.strikethrough\npink/attribute strikethrough","url":"pink/attribute.html#strikethrough"},{"doc":"pink/attribute","title":"underline","content":"pub fn underline(is_underline: Bool) -&gt; Attribute\n Make the text underlined\nSynonyms:\npink/attribute.underline\npink/attribute underline","url":"pink/attribute.html#underline"},{"doc":"pink/attribute","title":"width","content":"pub fn width(width: Dimension) -&gt; Attribute\n Width of the element.\n You can set it in `Spaces` or in `Percent`, which will calculate the width based on the width of parent element.\n ## Examples\n \n box([width(Spaces(4))], [text([], &quot;X&quot;)])\n // -&gt; X\n \n \n box([width(Spaces(10))], [\n   box([width(Percent(50))], [text([], &quot;X&quot;)]),\n   text([], &quot;Y&quot;)\n ])\n // -&gt; X    Y\n \nSynonyms:\npink/attribute.width\npink/attribute width","url":"pink/attribute.html#width"},{"doc":"pink/attribute","title":"wrap","content":"pub fn wrap(wrap: Wrap) -&gt; Attribute\n This property tells Ink to wrap or truncate text if its width is larger than container\n If wrap is passed (by default), Ink will wrap text and split it into multiple lines. If Truncate* is passed, Ink will truncate text instead, which will result in one line of text with the rest cut off\n\n ## Examples\n \n box([width(7)], [text([], &quot;Hello World&quot;)])\n // -&gt; &quot;Hello\\nWorld&quot;\n \n \n // Truncate is an alias to TruncateEnd\n box([width(7)], [text([wrap(Truncate)], &quot;Hello World&quot;)])\n // -&gt; &quot;Hello…&quot;\n \n \n box([width(7)], [text([wrap(TruncateMiddle)], &quot;Hello World&quot;)])\n // -&gt; &quot;He…ld&quot;\n \n \n box([width(7)], [text([wrap(TruncateStart)], &quot;Hello World&quot;)])\n // -&gt; &quot;…World&quot;\n \nSynonyms:\npink/attribute.wrap\npink/attribute wrap","url":"pink/attribute.html#wrap"},{"doc":"pink/attribute","title":"pink/attribute","content":"","url":"pink/attribute.html"},{"doc":"pink","title":"ReactNode","content":"pub type ReactNode\n A ReactNode is a representation of a component in the Ink library.\n\nSynonyms:\npink.ReactNode\npink ReactNode","url":"pink.html#ReactNode"},{"doc":"pink","title":"box","content":"pub fn box(\n  styles attributes: List(Attribute),\n  components children: List(ReactNode),\n) -&gt; ReactNode\n `box` is an essential Ink component to build your layout.\n\n It&#39;s like a `&lt;div style=&quot;display: flex&quot;&gt;` in the browser.\n\n ## Examples\n \n box(\n   styles: [\n     attribute.flex_direction(attribute.FlexColumn),\n     attribute.gap(1),\n   ],\n   components: [\n     text([], &quot;Hello, &quot;),\n     text([attribute.underline(True)], &quot;world!&quot;),\n   ]\n )\n \nSynonyms:\npink.box\npink box","url":"pink.html#box"},{"doc":"pink","title":"component","content":"pub fn component(element: fn() -&gt; ReactNode) -&gt; ReactNode\n Make a ReactNode from a function\n This is needed to use React hooks in the function\n\n ## Examples\n \n use &lt;- component()\n let is_loading = hook.state(False)\n `\nSynonyms:\npink.component\npink component","url":"pink.html#component"},{"doc":"pink","title":"fragment","content":"pub fn fragment(\n  attr attributes: List(Attribute),\n  elements children: List(ReactNode),\n) -&gt; ReactNode\n A React fragment is a way to group multiple elements together\n without adding extra nodes to the DOM.\n\n ## Examples\n \n fragment(attr: [], elements: [\n   box([attribute.padding(1)], [pink.text([], &quot;Hello, &quot;)]),\n   text([attribute.underline(True)], &quot;world!&quot;),\n ])\n \nSynonyms:\npink.fragment\npink fragment","url":"pink.html#fragment"},{"doc":"pink","title":"newline","content":"pub fn newline(settings attributes: List(Attribute)) -&gt; ReactNode\n Adds one or more newline (\\n) characters. Must be used within &lt;Text&gt; components.\n\n ## Examples\n \n text_nested([], [\n   text([], &quot;Hello, &quot;),\n   newline([attribute.count(2)]),\n   text([], &quot;world!&quot;)\n ])\n \nSynonyms:\npink.newline\npink newline","url":"pink.html#newline"},{"doc":"pink","title":"render","content":"pub fn render(component: ReactNode) -&gt; Nil\n Render a ReactNode to the terminal\n This is the main function to use to render components\n\n ## Examples\n \n render(\n   box(\n     [\n       attribute.flex_direction(attribute.FlexColumn),\n       attribute.gap(1),\n     ],\n     [\n       text([], &quot;Hello, &quot;),\n       text([attribute.underline(True)], &quot;world!&quot;),\n     ]\n   )\n )\n \nSynonyms:\npink.render\npink render","url":"pink.html#render"},{"doc":"pink","title":"spacer","content":"pub fn spacer() -&gt; ReactNode\n A flexible space that expands along the major axis of its containing layout. It&#39;s useful as a shortcut for filling all the available spaces between elements.\n For example, using &lt;Spacer&gt; in a &lt;Box&gt; with default flex direction (row) will position &quot;Left&quot; on the left side and will push &quot;Right&quot; to the right side.\n\n ## Examples\n \n box([], [\n   text([], &quot;Left&quot;),\n   spacer(),\n   text([], &quot;Right&quot;),\n ])\n box(\n   [\n     attribute.flex_direction(attribute.FlexColumn),\n     attribute.height(attribute.Spaces(10)),\n   ],\n   [text([], &quot;Top&quot;), spacer(), text([], &quot;Bottom&quot;)],\n )\n \nSynonyms:\npink.spacer\npink spacer","url":"pink.html#spacer"},{"doc":"pink","title":"spinner","content":"pub fn spinner(type_ type_: String) -&gt; ReactNode\n Spinner component for Ink. Uses [cli-spinners](https://github.com/sindresorhus/cli-spinners) for the collection of spinners.\n\n ## Examples\n \n spinner(type_: &quot;dots&quot;)\n \nSynonyms:\npink.spinner\npink spinner","url":"pink.html#spinner"},{"doc":"pink","title":"static","content":"pub fn static(\n  for items: List(a),\n  using callback: fn(a, Int) -&gt; ReactNode,\n) -&gt; ReactNode\n `static` component permanently renders its output above everything else. It&#39;s useful for displaying activity like completed tasks or logs - things that are not changing after they&#39;re rendered (hence the name &quot;Static&quot;).\n It&#39;s preferred to use &lt;Static&gt; for use cases like these, when you can&#39;t know or control the amount of items that need to be rendered.\n\n ## Examples\n \n fragment([], [\n   // This part will be rendered once to the terminal\n   static(for: tests, using: fn(test_, _index) {\n     box([attribute.key(test_)], [\n       text([attribute.color(&quot;green&quot;)], &quot;  &quot; &lt;&gt; test_),\n     ])\n   }),\n   // This part keeps updating as state changes\n   box([attribute.margin_top(1)], [\n     text([],\n       &quot;Completed tests: &quot; &lt;&gt; int.to_string(list.length(tests)),\n     ),\n   ]),\n ])\n \nSynonyms:\npink.static\npink static","url":"pink.html#static"},{"doc":"pink","title":"text","content":"pub fn text(\n  with attributes: List(Attribute),\n  displaying content: String,\n) -&gt; ReactNode\n This component can display text, and change its style to make it bold, underline, italic or strikethrough.\n It only supports text content. If you need to display other components within text, use `text_nested` instead.\n \n ## Examples\n \n text(with: [], displaying: &quot;Hello, world!&quot;)\n \nSynonyms:\npink.text\npink text","url":"pink.html#text"},{"doc":"pink","title":"text_nested","content":"pub fn text_nested(\n  attr attributes: List(Attribute),\n  content children: List(ReactNode),\n) -&gt; ReactNode\n The same as `text`, but allows you to nest other components within text.\n\n ## Examples\n \n text_nested(attr: [], content: [\n  text([attribute.bold(True)], &quot;Hello, &quot;),\n  text([attribute.underline(True)], &quot;world!&quot;),\n ])\n \nSynonyms:\npink.text_nested\npink text_nested","url":"pink.html#text_nested"},{"doc":"pink","title":"transform","content":"pub fn transform(\n  apply transform: fn(String, Int) -&gt; String,\n  on children: List(ReactNode),\n) -&gt; ReactNode\n Transform a string representation of React components before they are written to output. For example, you might want to apply a gradient to text, add a clickable link or create some text effects.\n These use cases can&#39;t accept React nodes as input, they are expecting a string. That&#39;s what &lt;Transform&gt; component does, it gives you an output string of its child components and lets you transform it in any way\n\n ## Examples\n \n transform(\n   apply: fn(output, _index) { string.uppercase(output) },\n   on: [text([], &quot;Hello, world&quot;)],\n )\n \nSynonyms:\npink.transform\npink transform","url":"pink.html#transform"},{"doc":"pink","title":"pink","content":"","url":"pink.html"},{"doc":"pink/app","title":"App","content":"pub type App\n\n\nSynonyms:\npink/app.App\npink/app App","url":"pink/app.html#App"},{"doc":"pink/app","title":"exit","content":"pub fn exit(app: App) -&gt; Nil\n Exit the app (unmount)\nSynonyms:\npink/app.exit\npink/app exit","url":"pink/app.html#exit"},{"doc":"pink/app","title":"get","content":"pub fn get() -&gt; App\n Get the current app instance\nSynonyms:\npink/app.get\npink/app get","url":"pink/app.html#get"},{"doc":"pink/app","title":"pink/app","content":"","url":"pink/app.html"},{"doc":"pink/focus","title":"Focus","content":"pub type Focus {\n  Focus(is_focused: Bool)\n}\n `Focus` is the type returned by the `focus` function\nFocus(is_focused: Bool)\n\n\nSynonyms:\npink/focus.Focus\npink/focus Focus","url":"pink/focus.html#Focus"},{"doc":"pink/focus","title":"FocusOptions","content":"pub opaque type FocusOptions\n `FocusOptions` is the type used by the `focus` function to configure the focus state.\n\nSynonyms:\npink/focus.FocusOptions\npink/focus FocusOptions","url":"pink/focus.html#FocusOptions"},{"doc":"pink/focus","title":"options","content":"pub fn options() -&gt; FocusOptions\n Create a new `FocusOptions` with the default values.\nSynonyms:\npink/focus.options\npink/focus options","url":"pink/focus.html#options"},{"doc":"pink/focus","title":"set_auto_focus","content":"pub fn set_auto_focus(\n  options: FocusOptions,\n  auto_focus: Bool,\n) -&gt; FocusOptions\n Set the `auto_focus` field on the `FocusOptions`.\n Auto focus this component, if there&#39;s no active (focused) component right now\nSynonyms:\npink/focus.set_auto_focus\npink/focus set_auto_focus","url":"pink/focus.html#set_auto_focus"},{"doc":"pink/focus","title":"set_id","content":"pub fn set_id(options: FocusOptions, id: String) -&gt; FocusOptions\n Set the `id` field on the `FocusOptions`.\n Set a component&#39;s focus ID, which can be used to programmatically focus the component. This is useful for large interfaces with many focusable elements, to avoid having to cycle through all of them\nSynonyms:\npink/focus.set_id\npink/focus set_id","url":"pink/focus.html#set_id"},{"doc":"pink/focus","title":"set_is_active","content":"pub fn set_is_active(\n  options: FocusOptions,\n  is_active: Bool,\n) -&gt; FocusOptions\n Set the `is_active` field on the `FocusOptions`.\n Enable or disable this component&#39;s focus, while still maintaining its position in the list of focusable components. This is useful for inputs that are temporarily disabled\nSynonyms:\npink/focus.set_is_active\npink/focus set_is_active","url":"pink/focus.html#set_is_active"},{"doc":"pink/focus","title":"pink/focus","content":"","url":"pink/focus.html"},{"doc":"pink/focus_manager","title":"FocusManager","content":"pub type FocusManager\n\n\nSynonyms:\npink/focus_manager.FocusManager\npink/focus_manager FocusManager","url":"pink/focus_manager.html#FocusManager"},{"doc":"pink/focus_manager","title":"disable_focus","content":"pub fn disable_focus(manager: FocusManager) -&gt; Nil\n Disable focus management for all components. Currently active component (if there&#39;s one) will lose its focus.\nSynonyms:\npink/focus_manager.disable_focus\npink/focus_manager disable_focus","url":"pink/focus_manager.html#disable_focus"},{"doc":"pink/focus_manager","title":"enable_focus","content":"pub fn enable_focus(manager: FocusManager) -&gt; Nil\n Enable focus management for all components\n\n Note: You don&#39;t need to call this method manually, unless you&#39;ve disabled focus management. Focus management is enabled by default\nSynonyms:\npink/focus_manager.enable_focus\npink/focus_manager enable_focus","url":"pink/focus_manager.html#enable_focus"},{"doc":"pink/focus_manager","title":"focus","content":"pub fn focus(manager: FocusManager, id: String) -&gt; Nil\n Switch focus to the component with the specified id. If there&#39;s no component with that ID, focus will be given to the next focusable component.\nSynonyms:\npink/focus_manager.focus\npink/focus_manager focus","url":"pink/focus_manager.html#focus"},{"doc":"pink/focus_manager","title":"focus_next","content":"pub fn focus_next(manager: FocusManager) -&gt; Nil\n Switch focus to the next focusable component.\n\n If there&#39;s no active component right now, focus will be given to the first focusable component. If active component is the last in the list of focusable components, focus will be switched to the first active component.\n\n Note: Ink calls this method when user presses Tab.\nSynonyms:\npink/focus_manager.focus_next\npink/focus_manager focus_next","url":"pink/focus_manager.html#focus_next"},{"doc":"pink/focus_manager","title":"focus_previous","content":"pub fn focus_previous(manager: FocusManager) -&gt; Nil\n Switch focus to the previous focusable component.\n\n If there&#39;s no active component right now, focus will be given to the last focusable component. If active component is the first in the list of focusable components, focus will be switched to the last active component.\n\n Note: Ink calls this method when user presses Shift+Tab.\nSynonyms:\npink/focus_manager.focus_previous\npink/focus_manager focus_previous","url":"pink/focus_manager.html#focus_previous"},{"doc":"pink/focus_manager","title":"get","content":"pub fn get() -&gt; FocusManager\n Get the Focus Manager that is able to enable or disable focus management for all components or manually switch focus to next or previous components.\nSynonyms:\npink/focus_manager.get\npink/focus_manager get","url":"pink/focus_manager.html#get"},{"doc":"pink/focus_manager","title":"pink/focus_manager","content":"","url":"pink/focus_manager.html"},{"doc":"pink/key","title":"Key","content":"pub type Key {\n  UpArrow\n  DownArrow\n  LeftArrow\n  RightArrow\n  PageDown\n  PageUp\n  Return\n  Escape\n  Ctrl\n  Shift\n  Tab\n  Backspace\n  Delete\n  Meta\n}\n A key on the keyboard.\nUpArrow\n\n\nDownArrow\n\n\nLeftArrow\n\n\nRightArrow\n\n\nPageDown\n\n\nPageUp\n\n\nReturn\n\n\nEscape\n\n\nCtrl\n\n\nShift\n\n\nTab\n\n\nBackspace\n\n\nDelete\n\n\nMeta\n\n\nSynonyms:\npink/key.Key\npink/key Key","url":"pink/key.html#Key"},{"doc":"pink/key","title":"pink/key","content":"","url":"pink/key.html"},{"doc":"pink/hook","title":"effect","content":"pub fn effect(\n  callback: fn() -&gt; Nil,\n  dependencies: List(a),\n) -&gt; Nil\n `effect` is a hook which allows you to perform side effects in function components.\n This is a React hook and not a Ink hook.\n Read more about it on [react.dev docs](https://react.dev/reference/react/useEffect)\n\n This hook is here for convenience, so you don&#39;t have to create the bindings yourself\n\n If you want to run a cleanup function when the component unmounts, use `effect_clean` instead\nSynonyms:\npink/hook.effect\npink/hook effect","url":"pink/hook.html#effect"},{"doc":"pink/hook","title":"effect_clean","content":"pub fn effect_clean(\n  callback: fn() -&gt; fn() -&gt; Nil,\n  dependencies: List(a),\n) -&gt; Nil\n This is the same as `effect`, but it also allows you to run a cleanup function when the component unmounts\nSynonyms:\npink/hook.effect_clean\npink/hook effect_clean","url":"pink/hook.html#effect_clean"},{"doc":"pink/hook","title":"focus","content":"pub fn focus(options: FocusOptions) -&gt; Focus\n Component that uses the `focus` hook becomes &quot;focusable&quot; to Ink, so when user presses Tab, Ink will switch focus to this component.\n\n If there are multiple components that execute useFocus hook, focus will be given to them in the order that these components are rendered in.\n\n This hook returns a record with `is_focused` boolean field, which determines if this component is focused or not\nSynonyms:\npink/hook.focus\npink/hook focus","url":"pink/hook.html#focus"},{"doc":"pink/hook","title":"input","content":"pub fn input(\n  callback: fn(String, List(Key)) -&gt; Nil,\n  is_active: Bool,\n) -&gt; Nil\n This hook is used for handling user input.\n It&#39;s a more convenient alternative to using `stdin` and listening to data events.\n The callback you pass to `input` is called for each character when user enters any input.\n However, if user pastes text and it&#39;s more than one character, the callback will be called only once and the whole string will be passed as input.\n\n The `is_active` option is used to enable or disable capturing of user input.\n Useful when there are multiple `input` hooks used at once to avoid handling the same input several times\n\n ## Examples\n \n component(fn() {\n   hook.input(fn(input, keys) {\n     case input, keys {\n       &quot;q&quot;, _ -&gt; // Exit program\n       _, [LeftArrow] -&gt; // Left arrow key pressed\n     }\n   }, True)\n })\n \nSynonyms:\npink/hook.input\npink/hook input","url":"pink/hook.html#input"},{"doc":"pink/hook","title":"pink/hook","content":"","url":"pink/hook.html"},{"doc":"pink/state","title":"State","content":"pub type State(a)\n A reference to a state value in a React component.\n\nSynonyms:\npink/state.State\npink/state State","url":"pink/state.html#State"},{"doc":"pink/state","title":"get","content":"pub fn get(state: State(a)) -&gt; a\n Get the current value of a state.\nSynonyms:\npink/state.get\npink/state get","url":"pink/state.html#get"},{"doc":"pink/state","title":"init","content":"pub fn init(value value: a) -&gt; State(a)\n Initialize a stateful value.\n\n This is a React hook.\n Read more about it on [react.dev docs](https://react.dev/reference/react/useState)\n\n Note: This hook is here for convenience, so you don&#39;t have to create the bindings yourself\nSynonyms:\npink/state.init\npink/state init","url":"pink/state.html#init"},{"doc":"pink/state","title":"set","content":"pub fn set(on state: State(a), value value: a) -&gt; Nil\n Set the value of a state.\nSynonyms:\npink/state.set\npink/state set","url":"pink/state.html#set"},{"doc":"pink/state","title":"set_with","content":"pub fn set_with(\n  on state: State(a),\n  with setter: fn(a) -&gt; a,\n) -&gt; Nil\n Update the value of a state using a function.\nSynonyms:\npink/state.set_with\npink/state set_with","url":"pink/state.html#set_with"},{"doc":"pink/state","title":"pink/state","content":"","url":"pink/state.html"},{"doc":"pink/stderr","title":"Stderr","content":"pub type Stderr\n\n\nSynonyms:\npink/stderr.Stderr\npink/stderr Stderr","url":"pink/stderr.html#Stderr"},{"doc":"pink/stderr","title":"get","content":"pub fn get() -&gt; Stderr\n Get the stderr stream.\nSynonyms:\npink/stderr.get\npink/stderr get","url":"pink/stderr.html#get"},{"doc":"pink/stderr","title":"stderr","content":"pub fn stderr(stderr: Stderr) -&gt; Dynamic\n process.stderr\nSynonyms:\npink/stderr.stderr\npink/stderr stderr","url":"pink/stderr.html#stderr"},{"doc":"pink/stderr","title":"write","content":"pub fn write(on stderr: Stderr, chunk chunk: String) -&gt; Nil\n Write any string to stderr, while preserving Ink&#39;s output.\n\n It&#39;s useful when you want to display some external information outside of Ink&#39;s rendering and ensure there&#39;s no conflict between the two. It&#39;s similar to `static`, except it can&#39;t accept components, it only works with strings\nSynonyms:\npink/stderr.write\npink/stderr write","url":"pink/stderr.html#write"},{"doc":"pink/stderr","title":"pink/stderr","content":"","url":"pink/stderr.html"},{"doc":"pink/stdin","title":"Stdin","content":"pub type Stdin\n\n\nSynonyms:\npink/stdin.Stdin\npink/stdin Stdin","url":"pink/stdin.html#Stdin"},{"doc":"pink/stdin","title":"get","content":"pub fn get() -&gt; Stdin\n Get the stdin stream\nSynonyms:\npink/stdin.get\npink/stdin get","url":"pink/stdin.html#get"},{"doc":"pink/stdin","title":"is_raw_mode_supported","content":"pub fn is_raw_mode_supported(stdin: Stdin) -&gt; Bool\n A boolean flag determining if the current stdin supports `set_raw_mode`.\n\n A component using `set_raw_mode` might want to use `is_raw_mode_supported` to nicely fall back in environments where raw mode is not supported\nSynonyms:\npink/stdin.is_raw_mode_supported\npink/stdin is_raw_mode_supported","url":"pink/stdin.html#is_raw_mode_supported"},{"doc":"pink/stdin","title":"set_raw_mode","content":"pub fn set_raw_mode(stdin: Stdin, raw_mode: Bool) -&gt; Nil\n See [setRawMode](https://nodejs.org/api/tty.html#tty_readstream_setrawmode_mode).\n\n Ink exposes this function to be able to handle Ctrl+C, that&#39;s why you should use Ink&#39;s `set_raw_mode` instead of `process.stdin.setRawMode`\nSynonyms:\npink/stdin.set_raw_mode\npink/stdin set_raw_mode","url":"pink/stdin.html#set_raw_mode"},{"doc":"pink/stdin","title":"stdin","content":"pub fn stdin(stdin: Stdin) -&gt; Dynamic\n Get the process.stdin. Useful if your app needs to handle user input\nSynonyms:\npink/stdin.stdin\npink/stdin stdin","url":"pink/stdin.html#stdin"},{"doc":"pink/stdin","title":"pink/stdin","content":"","url":"pink/stdin.html"},{"doc":"pink/stdout","title":"Stdout","content":"pub type Stdout\n\n\nSynonyms:\npink/stdout.Stdout\npink/stdout Stdout","url":"pink/stdout.html#Stdout"},{"doc":"pink/stdout","title":"get","content":"pub fn get() -&gt; Stdout\n Get the stdout stream, where Ink renders your app.\nSynonyms:\npink/stdout.get\npink/stdout get","url":"pink/stdout.html#get"},{"doc":"pink/stdout","title":"stdout","content":"pub fn stdout(stdout: Stdout) -&gt; Dynamic\n process.stdout\nSynonyms:\npink/stdout.stdout\npink/stdout stdout","url":"pink/stdout.html#stdout"},{"doc":"pink/stdout","title":"write","content":"pub fn write(on stdout: Stdout, chunk chunk: String) -&gt; Nil\n Write any string to stdout, while preserving Ink&#39;s output.\n\n It&#39;s useful when you want to display some external information outside of Ink&#39;s rendering and ensure there&#39;s no conflict between the two. It&#39;s similar to `static`, except it can&#39;t accept components, it only works with strings\nSynonyms:\npink/stdout.write\npink/stdout write","url":"pink/stdout.html#write"},{"doc":"pink/stdout","title":"pink/stdout","content":"","url":"pink/stdout.html"}]);